Index: LMDZ5/branches/testing/libf/phylmd/physiq.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/physiq.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/physiq.F90	(revision 2298)
@@ -47,4 +47,8 @@
   use phyaqua_mod, only: zenang_an
   USE control_mod
+#ifdef CPP_XIOS
+  USE wxios, ONLY: missing_val, missing_val_omp
+  USE xios, ONLY: xios_get_field_attr
+#endif
 #ifdef REPROBUS
   USE CHEM_REP, ONLY : Init_chem_rep_xjour
@@ -240,4 +244,7 @@
   real da(klon,klev),phi(klon,klev,klev),mp(klon,klev)
   real wght_cvfd(klon,klev)
+#ifndef CPP_XIOS
+  REAL, SAVE :: missing_val
+#endif
   ! Variables pour le lessivage convectif
   ! RomP >>> 
@@ -316,5 +323,10 @@
   SAVE top
   !$OMP THREADPRIVATE(bas, top)
-
+  !------------------------------------------------------------------
+  ! Upmost level reached by deep convection and related variable (jyg)
+  !
+  INTEGER izero
+  INTEGER k_upper_cv
+  !------------------------------------------------------------------
   !
   !=================================================================================================
@@ -528,5 +540,8 @@
   !                            !par la masse/airetot (moyglo_pondaima) et la vraie masse (moyglo_pondmass)
   !
-  ! Variables locales
+  !
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+  ! Local variables
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
   !
   REAL rhcl(klon,klev)    ! humiditi relative ciel clair
@@ -570,5 +585,7 @@
   REAL zx_t, zx_qs, zdelta, zcor, zlvdcp, zlsdcp
   real zqsat(klon,klev)
+!
   INTEGER i, k, iq, ig, j, nsrf, ll, l, iiq
+!
   REAL t_coup
   PARAMETER (t_coup=234.0)
@@ -885,4 +902,5 @@
      igout=klon/2+1/klon
      write(lunout,*) 'DEBUT DE PHYSIQ !!!!!!!!!!!!!!!!!!!!'
+     write(lunout,*) 'igout, rlat, rlon ',igout, rlatd(igout)*180./3.141593, rlond(igout)*180./3.141593
      write(lunout,*) &
           'nlon,klev,nqtot,debut,lafin, jD_cur, jH_cur,pdtphys'
@@ -904,5 +922,5 @@
 
   if (first) then 
-
+     
      !CR:nvelles variables convection/poches froides
 
@@ -957,4 +975,6 @@
   pde_u(:,:) = 0.
   aam=0.
+
+  alp_bl_conv(:)=0.
 
   torsfc=0.
@@ -1332,5 +1352,4 @@
      END IF
      !
-     !
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      ! Nouvelle initialisation pour le rayonnement RRTM
@@ -1413,8 +1432,6 @@
   !
   CALL change_srf_frac(itap, dtime, days_elapsed+1,  &
-!albedo SB >>>
-!       pctsrf, falb1, falb2, ftsol, ustar, u10m, v10m, pbl_tke)
-       pctsrf, falb_dir, falb_dif, ftsol, ustar, u10m, v10m, pbl_tke)
-!albedo SB <<<
+       pctsrf, fevap, z0m, z0h, agesno,              &
+       falb_dir, falb_dif, ftsol, ustar, u10m, v10m, pbl_tke)
 
   ! Update time and other variables in Reprobus
@@ -1547,12 +1564,16 @@
      ENDDO
 !!! RomP >>>   td dyn traceur
-     IF (nqtot.GE.3) THEN
-        DO iq = 3, nqtot
+!!     IF (nqtot.GE.3) THEN       ! jyg
+!!        DO iq = 3, nqtot        ! jyg
+     IF (nqtot.GE.nqo+1) THEN     ! jyg
+        DO iq = nqo+1, nqtot      ! jyg
            DO k = 1, klev
               DO i = 1, klon
-                 d_tr_dyn(i,k,iq-2)= &
-                      (tr_seri(i,k,iq-2)-tr_ancien(i,k,iq-2))/dtime
+!!                 d_tr_dyn(i,k,iq-2)= &                                 ! jyg
+!!                      (tr_seri(i,k,iq-2)-tr_ancien(i,k,iq-2))/dtime    ! jyg
+                 d_tr_dyn(i,k,iq-nqo)= &                                 ! jyg
+                      (tr_seri(i,k,iq-nqo)-tr_ancien(i,k,iq-nqo))/dtime  ! jyg
                  !         iiq=niadv(iq)
-                 !         print*,i,k," d_tr_dyn",d_tr_dyn(i,k,iq-2),"tra:",iq,tname(iiq)
+                 !         print*,i,k," d_tr_dyn",d_tr_dyn(i,k,iq-nqo),"tra:",iq,tname(iiq)
               ENDDO
            ENDDO
@@ -1570,9 +1591,12 @@
      ENDDO
 !!! RomP >>>   td dyn traceur
-     IF (nqtot.GE.3) THEN
-        DO iq = 3, nqtot
+!!     IF (nqtot.GE.3) THEN                                            ! jyg
+!!        DO iq = 3, nqtot                                             ! jyg
+     IF (nqtot.GE.nqo+1) THEN                                          ! jyg
+        DO iq = nqo+1, nqtot                                           ! jyg
            DO k = 1, klev
               DO i = 1, klon
-                 d_tr_dyn(i,k,iq-2)= 0.0
+!!                 d_tr_dyn(i,k,iq-2)= 0.0                             ! jyg
+                 d_tr_dyn(i,k,iq-nqo)= 0.0                             ! jyg
               ENDDO
            ENDDO
@@ -1809,5 +1833,5 @@
   !   s_capCL,   s_oliqCL,  s_cteiCL,s_pblT,
   !   s_therm,   s_trmb1,   s_trmb2, s_trmb3,
-  !   zxrugs,    zu10m,     zv10m,   fder,
+  !   zu10m,     zv10m,   fder,
   !   zxqsurf,   rh2m,      zxfluxu, zxfluxv,
   !   frugs,     agesno,    fsollw,  fsolsw,
@@ -1841,4 +1865,23 @@
 !>jyg+nrlmd
 !
+!-------gustiness calculation-------!
+     IF (iflag_gusts==0) THEN
+        gustiness(1:klon)=0
+     ELSE IF (iflag_gusts==1) THEN
+        do i = 1, klon
+           gustiness(i)=f_gust_bl*ale_bl(i)+f_gust_wk*ale_wake(i)
+        enddo
+!     ELSE IF (iflag_gusts==2) THEN
+!        do i = 1, klon
+!           gustiness(i)=f_gust_bl*ale_bl(i)+sigma_wk(i)*f_gust_wk*ale_wake(i) !! need to make sigma_wk accessible here
+!        enddo
+!     ELSE IF (iflag_gusts==3) THEN
+!        do i = 1, klon
+!           gustiness(i)=f_gust_bl*alp_bl(i)+f_gust_wk*alp_wake(i)
+!        enddo
+     ENDIF
+
+
+
      CALL pbl_surface(  &
           dtime,     date0,     itap,    days_elapsed+1, &
@@ -1847,4 +1890,5 @@
           zsig,      sollwdown, pphi,    cldt,      &
           rain_fall, snow_fall, solsw,   sollw,     &
+          gustiness,                                &
           t_seri,    q_seri,    u_seri,  v_seri,    &
 !nrlmd+jyg<
@@ -1852,6 +1896,4 @@
 !>nrlmd+jyg
           pplay,     paprs,     pctsrf,             &
-!albedo SB >>>
-!          ftsol,falb1,falb2,ustar,u10m,v10m,wstar,  &
           ftsol,SFRWL,falb_dir,falb_dif,ustar,u10m,v10m,wstar, &
 !albedo SB <<<
@@ -1882,7 +1924,7 @@
           s_capCL,   s_oliqCL,  s_cteiCL,s_pblT, &
           s_therm,   s_trmb1,   s_trmb2, s_trmb3, &
-          zxrugs,    zustar, zu10m,     zv10m,   fder, &
+          zustar, zu10m,     zv10m,   fder, &
           zxqsurf,   rh2m,      zxfluxu, zxfluxv, &
-          frugs,     agesno,    fsollw,  fsolsw, &
+          z0m, z0h,     agesno,    fsollw,  fsolsw, &
           d_ts,      fevap,     fluxlat, t2m, &
           wfbils,    wfbilo,    fluxt,   fluxu,  fluxv, &
@@ -2151,4 +2193,5 @@
         ! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 ! Estimation d'une vitesse verticale effective pour ALP
+        if (1==0) THEN
         www(1:klon)=0.
         do k=2,klev-1
@@ -2166,4 +2209,5 @@
            if (www(i)>0. .and. ale_bl(i)>0. ) www(i)=www(i)/ale_bl(i)
         enddo
+        ENDIF
 
 
@@ -2178,4 +2222,6 @@
               ALP(i) = alp_wake(i) + Alp_bl(i) + alp_offset ! modif sb
            else
+       abort_message ='Ne pas passer la car www non calcule'
+       CALL abort_gcm (modname,abort_message,1)
 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -2222,5 +2268,19 @@
      !
      IF (ok_cvl) THEN ! new driver for convectL
-
+     !
+!jyg<
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+     ! Calculate the upmost level of deep convection loops: k_upper_cv
+     !  (near 22 km)
+   izero = klon/2+1/klon
+   k_upper_cv = klev
+   DO k = klev,1,-1
+     IF (pphi(izero,k) > 22.e4) k_upper_cv = k
+   ENDDO
+   IF (prt_level .ge. 5) THEN
+     Print *, 'upmost level of deep convection loops: k_upper_cv = ',k_upper_cv
+   ENDIF
+     !
+!>jyg
         IF (type_trac == 'repr') THEN
            nbtr_tmp=ntra
@@ -2231,5 +2291,5 @@
         !c          CALL concvl (iflag_con,iflag_clos,
         CALL concvl (iflag_clos, &
-             dtime,paprs,pplay,t_undi,q_undi, &
+             dtime, paprs, pplay, k_upper_cv, t_undi,q_undi, &
              t_wake,q_wake,wake_s, &
              u_seri,v_seri,tr_seri,nbtr_tmp, &
@@ -3382,16 +3442,4 @@
 !albedo SB <<<
 
-!albedo SB >>>
-!     DO i = 1, klon
-!        albsol1(i) = falb1(i,is_oce) * pctsrf(i,is_oce) &
-!             + falb1(i,is_lic) * pctsrf(i,is_lic) &
-!             + falb1(i,is_ter) * pctsrf(i,is_ter) &
-!             + falb1(i,is_sic) * pctsrf(i,is_sic)
-!        albsol2(i) = falb2(i,is_oce) * pctsrf(i,is_oce) &
-!             + falb2(i,is_lic) * pctsrf(i,is_lic) &
-!             + falb2(i,is_ter) * pctsrf(i,is_ter) &
-!             + falb2(i,is_sic) * pctsrf(i,is_sic)
-!     ENDDO
-!albedo SB <<<
 
      if (mydebug) then
@@ -3935,4 +3983,16 @@
   !IM Interpolation sur les niveaux de pression du NMC
   !   -------------------------------------------------
+#ifdef CPP_XIOS
+          !$OMP MASTER
+          !On recupere la valeur de la missing value donnee dans le xml
+          CALL xios_get_field_attr("t850",default_value=missing_val_omp)
+!         PRINT *,"ARNAUD value missing ",missing_val_omp
+          !$OMP END MASTER
+          !$OMP BARRIER
+          missing_val=missing_val_omp
+#endif
+#ifndef CPP_XIOS
+          missing_val=missing_val_nf90
+#endif
   !
   include "calcul_STDlev.h"
@@ -4313,3 +4373,4 @@
   ENDDO
   RETURN
-END SUBROUTINE gr_fi_ecrit
+  END SUBROUTINE gr_fi_ecrit
+
Index: LMDZ5/branches/testing/libf/phylmd/phytrac_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/phytrac_mod.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/phytrac_mod.F90	(revision 2298)
@@ -769,5 +769,8 @@
              ! Liu (2001) proposed to use 1.5e-3 kg/kg
 
-             CALL lsc_scav(pdtphys,it,iflag_lscav,ql_incl,prfl,psfl,rneb,beta_fisrt,  &
+!jyg<
+!!             CALL lsc_scav(pdtphys,it,iflag_lscav,ql_incl,prfl,psfl,rneb,beta_fisrt,  &
+             CALL lsc_scav(pdtphys,it,iflag_lscav,aerosol,ql_incl,prfl,psfl,rneb,beta_fisrt,  &
+!>jyg
                   beta_v1,pplay,paprs,t_seri,tr_seri,d_tr_insc,   &
                   d_tr_bcscav,d_tr_evapls,qPrls)
Index: LMDZ5/branches/testing/libf/phylmd/plevel.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/plevel.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/plevel.F90	(revision 2298)
@@ -9,4 +9,10 @@
   USE netcdf
   USE dimphy
+#ifdef CPP_IOIPSL 
+  USE phys_state_var_mod, ONLY: missing_val_nf90 
+#endif
+#ifdef CPP_XIOS
+  USE wxios, ONLY: missing_val
+#endif
   IMPLICIT NONE
 
@@ -56,7 +62,14 @@
   INTEGER i, k
 
-  REAL missing_val
+! REAL missing_val
+#ifndef CPP_XIOS
+  REAL :: missing_val
+#endif
 
-  missing_val = nf90_fill_real
+! missing_val = nf90_fill_real
+
+#ifndef CPP_XIOS
+      missing_val=missing_val_nf90
+#endif
 
   IF (first) THEN
Index: LMDZ5/branches/testing/libf/phylmd/plevel_new.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/plevel_new.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/plevel_new.F90	(revision 2298)
@@ -10,4 +10,11 @@
   USE netcdf
   USE dimphy
+#ifdef CPP_IOIPSL 
+  USE phys_state_var_mod, ONLY: missing_val_nf90
+#endif
+#ifdef CPP_XIOS
+  USE wxios, ONLY: missing_val
+#endif
+
   IMPLICIT NONE
 
@@ -58,7 +65,14 @@
   INTEGER i, k
 
-  REAL missing_val
+! REAL missing_val
+#ifndef CPP_XIOS
+  REAL :: missing_val
+#endif
 
-  missing_val = nf90_fill_real
+! missing_val = nf90_fill_real
+
+#ifndef CPP_XIOS
+      missing_val=missing_val_nf90
+#endif
 
   IF (first) THEN
Index: LMDZ5/branches/testing/libf/phylmd/screenc.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/screenc.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/screenc.F90	(revision 2298)
@@ -4,5 +4,5 @@
       SUBROUTINE screenc(klon, knon, nsrf, zxli, &
                          speed, temp, q_zref, zref, &
-                         ts, qsurf, rugos, psol, &
+                         ts, qsurf, z0m, z0h, psol, &
                          ustar, testar, qstar, okri, ri1, &
                          pref, delu, delte, delq)
@@ -30,5 +30,5 @@
 ! ts------input-R- temperature de l'air a la surface
 ! qsurf---input-R- humidite relative a la surface
-! rugos---input-R- rugosite
+! z0m, z0h---input-R- rugosite
 ! psol----input-R- pression au sol
 ! ustar---input-R- facteur d'echelle pour le vent
@@ -48,5 +48,5 @@
       REAL, dimension(klon), intent(in) :: speed, temp, q_zref
       REAL, intent(in) :: zref
-      REAL, dimension(klon), intent(in) :: ts, qsurf, rugos, psol
+      REAL, dimension(klon), intent(in) :: ts, qsurf, z0m, z0h, psol
       REAL, dimension(klon), intent(in) :: ustar, testar, qstar, ri1         
 !
@@ -75,5 +75,5 @@
       CALL cdrag (knon, nsrf, &
                     speed, temp, q_zref, gref, &
-                    psol, ts, qsurf, rugos, &
+                    psol, ts, qsurf, z0m, z0h, &
                     cdram, cdrah, zri1, pref)
       DO i = 1, knon
Index: LMDZ5/branches/testing/libf/phylmd/stdlevvar.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/stdlevvar.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/stdlevvar.F90	(revision 2298)
@@ -4,5 +4,5 @@
       SUBROUTINE stdlevvar(klon, knon, nsrf, zxli, &
                            u1, v1, t1, q1, z1, &
-                           ts1, qsurf, rugos, psol, pat1, &
+                           ts1, qsurf, z0m, z0h, psol, pat1, &
                            t_2m, q_2m, t_10m, q_10m, u_10m, ustar)
       IMPLICIT NONE
@@ -32,5 +32,5 @@
 ! ts1-----input-R- temperature de l'air a la surface
 ! qsurf---input-R- humidite relative a la surface
-! rugos---input-R- rugosite
+! z0m, z0h---input-R- rugosite
 ! psol----input-R- pression au sol
 ! pat1----input-R- pression au 1er niveau du modele
@@ -47,5 +47,5 @@
       LOGICAL, intent(in) :: zxli
       REAL, dimension(klon), intent(in) :: u1, v1, t1, q1, z1, ts1
-      REAL, dimension(klon), intent(in) :: qsurf, rugos
+      REAL, dimension(klon), intent(in) :: qsurf, z0m, z0h
       REAL, dimension(klon), intent(in) :: psol, pat1
 !
@@ -103,7 +103,8 @@
 ! &                   cdram, cdrah, cdran, zri1, pref)            
 ! Fuxing WANG, 04/03/2015, replace the coefcdrag by the merged version: cdrag
+
       CALL cdrag(knon, nsrf, &
  &                   speed, t1, q1, z1, &
- &                   psol, ts1, qsurf, rugos, &
+ &                   psol, ts1, qsurf, z0m, z0h, &
  &                   cdram, cdrah, zri1, pref)
 
@@ -139,5 +140,5 @@
       zref = 2.0
       CALL screenp(klon, knon, nsrf, speed, tpot, q1, &
- &                 ts1, qsurf, rugos, lmon, &
+ &                 ts1, qsurf, z0m, lmon, &
  &                 ustar, testar, qstar, zref, &
  &                 delu, delte, delq)
@@ -160,5 +161,5 @@
         CALL screenc(klon, knon, nsrf, zxli, &
  &                   u_zref, temp, q_zref, zref, &
- &                   ts1, qsurf, rugos, psol, &           
+ &                   ts1, qsurf, z0m, z0h, psol, &           
  &                   ustar, testar, qstar, okri, ri1, &
  &                   pref, delu, delte, delq) 
@@ -241,5 +242,5 @@
       zref = 10.0
       CALL screenp(klon, knon, nsrf, speed, tpot, q1, &
- &                 ts1, qsurf, rugos, lmon, &
+ &                 ts1, qsurf, z0m, lmon, &
  &                 ustar, testar, qstar, zref, &
  &                 delu, delte, delq)
@@ -262,5 +263,5 @@
         CALL screenc(klon, knon, nsrf, zxli, &
  &                   u_zref, temp, q_zref, zref, &
- &                   ts1, qsurf, rugos, psol, &
+ &                   ts1, qsurf, z0m, z0h, psol, &
  &                   ustar, testar, qstar, okri, ri1, &
  &                   pref, delu, delte, delq)
Index: LMDZ5/branches/testing/libf/phylmd/surf_land_bucket_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/surf_land_bucket_mod.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/surf_land_bucket_mod.F90	(revision 2298)
@@ -13,5 +13,5 @@
        tsurf, p1lay, tq_cdrag, precip_rain, precip_snow, temp_air, &
        spechum, petAcoef, peqAcoef, petBcoef, peqBcoef, pref, &
-       u1, v1, rugoro, swnet, lwnet, &
+       u1, v1, gustiness, rugoro, swnet, lwnet, &
        snow, qsol, agesno, tsoil, &
        qsurf, z0_new, alb1_new, alb2_new, evap, &
@@ -49,5 +49,5 @@
     REAL, DIMENSION(klon), INTENT(IN)       :: petBcoef, peqBcoef
     REAL, DIMENSION(klon), INTENT(IN)       :: pref
-    REAL, DIMENSION(klon), INTENT(IN)       :: u1, v1
+    REAL, DIMENSION(klon), INTENT(IN)       :: u1, v1, gustiness
     REAL, DIMENSION(klon), INTENT(IN)       :: rugoro
     REAL, DIMENSION(klon), INTENT(IN)       :: swnet, lwnet
@@ -99,5 +99,5 @@
     CALL calbeta(dtime, is_ter, knon, snow, qsol, beta, capsol, dif_grnd)
     if (type_veget=='betaclim') then
-       CALL calbeta_clim(knon,jour,rlatd(knindex(:)),beta)
+       CALL calbeta_clim(knon,jour,rlatd(knindex(1:knon)),beta)
     endif
        
@@ -123,8 +123,8 @@
 
     CALL calcul_fluxs(knon, is_ter, dtime, &
-         tsurf, p1lay, cal, beta, tq_cdrag, pref, &
+         tsurf, p1lay, cal, beta, tq_cdrag, tq_cdrag, pref, &
          precip_rain, precip_snow, snow, qsurf,  &
-         radsol, dif_grnd, temp_air, spechum, u1_lay, v1_lay, &
-         petAcoef, peqAcoef, petBcoef, peqBcoef, &
+         radsol, dif_grnd, temp_air, spechum, u1_lay, v1_lay, gustiness, &
+         1.,petAcoef, peqAcoef, petBcoef, peqBcoef, &
          tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l)
     
Index: LMDZ5/branches/testing/libf/phylmd/surf_land_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/surf_land_mod.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/surf_land_mod.F90	(revision 2298)
@@ -14,11 +14,8 @@
        AcoefH, AcoefQ, BcoefH, BcoefQ, &
        AcoefU, AcoefV, BcoefU, BcoefV, & 
-       pref, u1, v1, rugoro, pctsrf, &
+       pref, u1, v1, gustiness, rugoro, pctsrf, &
        lwdown_m, q2m, t2m, &
        snow, qsol, agesno, tsoil, &
-!albedo SB >>>
-!      z0_new, alb1_new, alb2_new, evap, fluxsens, fluxlat, &
-       z0_new, SFRWL, alb_dir_new, alb_dif_new, evap, fluxsens, fluxlat, &   
-!albedo SB <<<
+       z0m, z0h, SFRWL, alb_dir_new, alb_dif_new, evap, fluxsens, fluxlat, &   
        qsurf, tsurf_new, dflux_s, dflux_l, &
        flux_u1, flux_v1 ) 
@@ -61,5 +58,5 @@
     REAL, DIMENSION(klon), INTENT(IN)       :: AcoefU, AcoefV, BcoefU, BcoefV
     REAL, DIMENSION(klon), INTENT(IN)       :: pref   ! pressure reference
-    REAL, DIMENSION(klon), INTENT(IN)       :: u1, v1
+    REAL, DIMENSION(klon), INTENT(IN)       :: u1, v1, gustiness
     REAL, DIMENSION(klon), INTENT(IN)       :: rugoro
     REAL, DIMENSION(klon,nbsrf), INTENT(IN) :: pctsrf
@@ -76,5 +73,5 @@
 ! Output variables
 !****************************************************************************************
-    REAL, DIMENSION(klon), INTENT(OUT)       :: z0_new
+    REAL, DIMENSION(klon), INTENT(OUT)       :: z0m, z0h
 !albedo SB >>>
 !    REAL, DIMENSION(klon), INTENT(OUT)       :: alb1_new ! albdeo for shortwave interval 1(visible)
@@ -137,5 +134,5 @@
             knindex, rlon, rlat, pctsrf, &
             debut, lafin, &
-            zlev,  u1, v1, temp_air, spechum, epot_air, ccanopy, & 
+            zlev,  u1, v1, gustiness, temp_air, spechum, epot_air, ccanopy, & 
             cdragh, AcoefH, AcoefQ, BcoefH, BcoefQ, &
             precip_rain, precip_snow, lwdown_m, swnet, swdown, &
@@ -143,5 +140,6 @@
             evap, fluxsens, fluxlat, &              
             tsol_rad, tsurf_new, alb1_new, alb2_new, &
-            emis_new, z0_new, qsurf)       
+            emis_new, z0m, qsurf)       
+        z0h(1:knon)=z0m(1:knon) ! En attendant mieux
 
 !  
@@ -149,5 +147,5 @@
 !  
        DO i=1,knon
-          z0_new(i) = MAX(1.5e-05,SQRT(z0_new(i)**2 + rugoro(i)**2))
+          z0m(i) = MAX(1.5e-05,SQRT(z0m(i)**2 + rugoro(i)**2))
        ENDDO
 
@@ -160,8 +158,9 @@
             tsurf, p1lay, cdragh, precip_rain, precip_snow, temp_air, &
             spechum, AcoefH, AcoefQ, BcoefH, BcoefQ, pref, &
-            u1, v1, rugoro, swnet, lwnet, &
+            u1, v1, gustiness, rugoro, swnet, lwnet, &
             snow, qsol, agesno, tsoil, &
-            qsurf, z0_new, alb1_new, alb2_new, evap, &
+            qsurf, z0m, alb1_new, alb2_new, evap, &
             fluxsens, fluxlat, tsurf_new, dflux_s, dflux_l)
+        z0h(1:knon)=z0m(1:knon) ! En attendant mieux
 
     ENDIF ! ok_veget
@@ -175,5 +174,5 @@
     v0(:)=0.0
     CALL calcul_flux_wind(knon, dtime, &
-         u0, v0, u1, v1, cdragm, &
+         u0, v0, u1, v1, gustiness, cdragm, &
          AcoefU, AcoefV, BcoefU, BcoefV, &
          p1lay, temp_air, &
Index: LMDZ5/branches/testing/libf/phylmd/surf_land_orchidee_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/surf_land_orchidee_mod.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/surf_land_orchidee_mod.F90	(revision 2298)
@@ -33,5 +33,5 @@
        knindex, rlon, rlat, pctsrf, &
        debut, lafin, &
-       plev,  u1_lay, v1_lay, temp_air, spechum, epot_air, ccanopy, & 
+       plev,  u1_lay, v1_lay, gustiness, temp_air, spechum, epot_air, ccanopy, & 
        tq_cdrag, petAcoef, peqAcoef, petBcoef, peqBcoef, &
        precip_rain, precip_snow, lwdown, swnet, swdown, &
@@ -115,5 +115,5 @@
     REAL, DIMENSION(klon), INTENT(IN)         :: rlon, rlat
     REAL, DIMENSION(klon), INTENT(IN)         :: plev
-    REAL, DIMENSION(klon), INTENT(IN)         :: u1_lay, v1_lay
+    REAL, DIMENSION(klon), INTENT(IN)         :: u1_lay, v1_lay, gustiness
     REAL, DIMENSION(klon), INTENT(IN)         :: temp_air, spechum
     REAL, DIMENSION(klon), INTENT(IN)         :: epot_air, ccanopy
Index: LMDZ5/branches/testing/libf/phylmd/surf_landice_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/surf_landice_mod.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/surf_landice_mod.F90	(revision 2298)
@@ -15,10 +15,7 @@
        AcoefH, AcoefQ, BcoefH, BcoefQ, &
        AcoefU, AcoefV, BcoefU, BcoefV, &
-       ps, u1, v1, rugoro, pctsrf, &
+       ps, u1, v1, gustiness, rugoro, pctsrf, &
        snow, qsurf, qsol, agesno, &
-!albedo SB >>>
-!      tsoil, z0_new, alb1, alb2, evap, fluxsens, fluxlat, &
-       tsoil, z0_new, SFRWL, alb_dir, alb_dif, evap, fluxsens, fluxlat, &
-!albedo SB <<<
+       tsoil, z0m, z0h, SFRWL, alb_dir, alb_dif, evap, fluxsens, fluxlat, &
        tsurf_new, dflux_s, dflux_l, &
        slope, cloudf, &
@@ -59,5 +56,5 @@
     REAL, DIMENSION(klon), INTENT(IN)             :: AcoefU, AcoefV, BcoefU, BcoefV
     REAL, DIMENSION(klon), INTENT(IN)             :: ps
-    REAL, DIMENSION(klon), INTENT(IN)             :: u1, v1
+    REAL, DIMENSION(klon), INTENT(IN)             :: u1, v1, gustiness
     REAL, DIMENSION(klon), INTENT(IN)             :: rugoro
     REAL, DIMENSION(klon,nbsrf), INTENT(IN)       :: pctsrf
@@ -82,5 +79,5 @@
 !****************************************************************************************
     REAL, DIMENSION(klon), INTENT(OUT)            :: qsurf
-    REAL, DIMENSION(klon), INTENT(OUT)            :: z0_new
+    REAL, DIMENSION(klon), INTENT(OUT)            :: z0m, z0h
 !albedo SB >>>
 !    REAL, DIMENSION(klon), INTENT(OUT)            :: alb1  ! new albedo in visible SW interval
@@ -182,7 +179,7 @@
           tsoil0(i,:)=tsoil(i,:)
        END DO
-	   ! Martin
-	   PRINT*, 'on appelle surf_sisvat'
-	   ! Martin
+           ! Martin
+           PRINT*, 'on appelle surf_sisvat'
+           ! Martin
        CALL surf_sisvat(knon, rlon, rlat, knindex, itime, dtime, debut, lafin, &
             rmu0, swdown, lwdown, pexner, ps, p1lay, &
@@ -194,5 +191,6 @@
             run_off_lic, evap, fluxsens, fluxlat, dflux_s, dflux_l, &        
             tsurf_new, alb1, alb2, alb3, &
-            emis_new, z0_new, qsurf)
+            emis_new, z0m, qsurf)
+       z0h(1:knon)=z0m(1:knon) ! en attendant mieux
        
        ! Suppose zero surface speed
@@ -205,5 +203,5 @@
        
        CALL calcul_flux_wind(knon, dtime, &
-            u0, v0, u1, v1, cdragm, &
+            u0, v0, u1, v1, gustiness, cdragm, &
             AcoefU, AcoefV, BcoefU, BcoefV, &
             p1lay, temp_air, &
@@ -243,12 +241,12 @@
 
     CALL calcul_fluxs(knon, is_lic, dtime, &
-         tsurf, p1lay, cal, beta, cdragh, ps, &
+         tsurf, p1lay, cal, beta, cdragh, cdragh, ps, &
          precip_rain, precip_snow, snow, qsurf,  &
-         radsol, dif_grnd, temp_air, spechum, u1_lay, v1_lay, &
-         AcoefH, AcoefQ, BcoefH, BcoefQ, &
+         radsol, dif_grnd, temp_air, spechum, u1_lay, v1_lay, gustiness, &
+         1.,AcoefH, AcoefQ, BcoefH, BcoefQ, &
          tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l)
 
     CALL calcul_flux_wind(knon, dtime, &
-         u0, v0, u1, v1, cdragm, &
+         u0, v0, u1, v1, gustiness, cdragm, &
          AcoefU, AcoefV, BcoefU, BcoefV, &
          p1lay, temp_air, &
@@ -290,5 +288,8 @@
 !
 !****************************************************************************************
-    z0_new(:) = MAX(1.E-3,rugoro(:))
+    z0m=1.e-3
+    z0h = z0m
+    z0m = SQRT(z0m**2+rugoro**2)
+
     END IF ! ok_snow
 
